## mupdf 1.13.0+ds1

=== debian/changelog ===
mupdf (1.13.0+ds1-3) unstable; urgency=medium

  * debian/patches: import upstream patch for CVE-2018-10289 (Closes: 896545)
  * More FTCBFS patches.
    Thanks to Helmut Grohne for the patches. (Closes: 903319)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 03 Sep 2018 09:10:50 +0900

mupdf (1.13.0+ds1-2) unstable; urgency=medium

  * Use dh_auto_build/dh_auto_install --parallel.
    Thanks to Helmut Grohne for the patch (Closes: #902968)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 08 Jul 2018 15:17:02 +0900

mupdf (1.13.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.13.0+ds1
    - Fixes CVE-2018-5686 (Closes: #887130)
    - Fixes CVE-2018-6187 (Closes: #888464)
    - Fixes CVE-2018-6192 (Closes: #888487)
  * debian/control: Migrate vcs to salsa.debian.org
  * debian/patches: Refresh patches
  * debian/rules: Build with Debian CFLAGS and enable PIC libmupdf.a
    (Closes: #841403)
  * debian/rules: use Debian flavor build options (Closes: #877067)
  * debian/mupdf.sh: Do not read from a file descriptor
    (Closes: #893115, #893862)
  * debian/mupdf.desktop: Fixes and add ePub and XPS to supported mimetype.
    Thanks to Pino Toscano, Hartmut Buhrmester (Closes: #877082)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 30 Apr 2018 11:17:25 +0900
