=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
-Build-Depends: debhelper (>= 7.0.50~), dpkg-dev (>= 1.16.1.1~),
+Build-Depends: debhelper (>= 7.4.10~), dpkg-dev (>= 1.16.1.1~),
  libfreetype6-dev, pkg-config, libjpeg-dev, libjbig2dec-dev,
  libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
  libharfbuzz-dev, freeglut3-dev
 Standards-Version: 4.1.1
 Homepage: http://mupdf.com/
-Vcs-Git: git://git.debian.org/git/users/koster/mupdf.git
-Vcs-Browser: http://git.debian.org/?p=users/koster/mupdf.git;a=summary
+Vcs-Git: https://salsa.debian.org/koster/mupdf.git
+Vcs-Browser: https://salsa.debian.org/koster/mupdf
 
 Package: libmupdf-dev
 Architecture: any
