## mupdf 1.14.0

=== debian/changelog ===
mupdf (1.14.0-0.1~mx17+1) mx; urgency=medium

  * New upstream release; build for MX 17.
  * Improve debian/mupdf.desktop by adding more mimetypes. Copied from Arch.
  * Disable automatic dbgsym packages.
  * Bump up to debhelper 9 compat.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 22 Oct 2018 18:28:31 -0700

mupdf (1.14.0-0build1+ubuntu16.04) xenial; urgency=low

  * New upstream release 

 -- pandajim (key for lives deb) <ubuntuhandbook1@gmail.com>  Sat, 06 Aug 2016 13:44:07 +0200
