## mupdf 1.14.0+ds1

=== debian/changelog ===
mupdf (1.14.0+ds1-4+deb10u3) buster; urgency=high

  * Non-maintainer upload.
  * Avoid a use-after-free in fz_drop_band_writer (CVE-2020-16600)
    (Closes: #989526)
  * Fix double free of object during linearization (CVE-2021-3407)
    (Closes: #983684)

 -- Bastian Germann <bastiangermann@fishpost.de>  Fri, 19 Feb 2021 08:55:54 +0100

mupdf (1.14.0+ds1-4+deb10u2) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Detect/avoid overflow when calculating sizes of pixmaps (CVE-2020-26519)
    (Closes: #971595)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 07 Nov 2020 10:20:45 +0100

mupdf (1.14.0+ds1-4+deb10u1) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Heap-based buffer overflow in fz_append_display_node (CVE-2019-13290)
    (Closes: #931475)

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 28 Aug 2020 20:42:12 +0200

mupdf (1.14.0+ds1-4) unstable; urgency=medium

  [ Salvatore Bonaccorso ]
  * Avoid being smart about keeping only a single reference to the buffer
    (CVE-2018-16647)   
    (Closes: #924351)
  * Fix text used as clip mask in pdfwrite device (CVE-2018-16648)
    (Closes: #924351)
  * Fix typo in pdf write device

  [ Kan-Ru Chen ]
  * Add more options to mupdf wrapper and display usage correctly

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 16 Mar 2019 09:42:00 +0900

mupdf (1.14.0+ds1-3) unstable; urgency=high

  * d/patches: import upstream fixes for various bugs.
    Fixes CVE-2018-18662, CVE-2019-6131, CVE-2019-6130
    (Closes: #912013, #918970, #918971)
  * d/control: Bump Standards-Version to 4.3.0, no changes required
  * Fix FTCBFS
    + Supply a cross LD for wrapping fonts.
    + Supply PKG_CONFIG to all make targets.
    Thanks to Helmut Grohne for the patch (Closes: #913515)
  * Regenerate cmaps from source.
    Thanks to Helmut Grohne for the suggestion
  * d/patches/0007-typographical-and-formatting-fixes-to-the-manual.patch:
    typographical and formatting fixes to the manual.
    Thanks to Bjarni Ingi Gislason for the patch

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 19 Jan 2019 12:01:19 +0900

mupdf (1.14.0+ds1-2) unstable; urgency=medium

  * Fix FTBFS on mips64el
    Disabled objcopy to avoid linking error.
  * Bump Standards-Version to 4.2.1
    Supports noopt and terse in DEB_BUILD_OPTIONS.

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 04 Nov 2018 09:13:26 +0900

mupdf (1.14.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.14.0+ds1
    - Fixes CVE-2018-1000036 (Closes: #900129, upstream bug 699695)
  * d/patches: fresh patches
  * d/rules: adjust to work with updated upstream Makefile
  * d/rules: Set CC_FOR_BUILD (Closes: #903319)

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 28 Oct 2018 14:48:12 +0900
