=== debian/changelog ===
mupdf (1.14.0.2+ds1-4+deb10u3+dde) unstable; urgency=medium

  * update

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Wed, 08 Sep 2021 11:46:58 +0800

mupdf (1.14.0.2+ds1-4+deb10u3+dde) buster; urgency=high

  * Non-maintainer upload.
  * Rebuild
  * Update version

 -- wangpei <wangpei@uniontech.com>  Wed, 8 Sep 2021 09:32:23 +0800

mupdf (1.14.0.1+ds1-4+deb10u3) buster; urgency=high

  * Non-maintainer upload.
  * Avoid a use-after-free in fz_drop_band_writer (CVE-2020-16600)
    (Closes: #989526)
  * Fix double free of object during linearization (CVE-2021-3407)
    (Closes: #983684)

 -- Bastian Germann <bastiangermann@fishpost.de>  Fri, 19 Feb 2021 08:55:54 +0100
